QuickPasswords.Preferences = {
	service: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),

	isDebug: function () {
		return this.service.getBoolPref("extensions.quickpasswords.debug");
	},

	isDebugOption: function(option) { // granular debugging
		if(!this.isDebug()) return false;
		try {return this.service.getBoolPref("extensions.quickpasswords.debug." + option);}
		catch(e) {return false;}
	},

	setUrlEntries: function(UrlEntries) { // store array as JSON string
		var json = JSON.stringify(UrlEntries)

		QuickPasswords.Util.logDebug(json)

		this.service.setCharPref("extensions.quickPasswords.Urls",json)
	} ,

	getUrlEntries: function() { // retrieve a list of values...
		if(!this.service.prefHasUserValue("extensions.quickPasswords.Urls")) {
			return [];
		}

		var Urls;

		if((Urls = this.service.getCharPref("extensions.quickPasswords.Urls"))) {
			return JSON.parse(Urls);
		}
		else {
			return [];
		}
	} ,

	isCopyMsg: function() {
		return this.service.getBoolPref("extensions.quickpasswords.copyMsg");
	} ,

	isMultiRowHeader: function() {
		return this.service.getBoolPref("extensions.quickpasswords.multiRowHeader");
	} ,

	isAutoClose: function() {
		return this.service.getBoolPref("extensions.quickpasswords.autoCloseManager");
	} ,

	isContextMenu: function() { // obsolete
		return this.service.getBoolPref("extensions.quickpasswords.displayContextMenu"); // obsolete!
	} ,

	contextMenuOption: function() {
		return this.service.getIntPref("extensions.quickpasswords.displayContextMenuChoice");
	},

	waitForManager: function() {
		return this.getIntPref('extensions.quickpasswords.waitForManagerTime');
	},

	getInstantApplyPref: function() {
		return this.service.getBoolPref("browser.preferences.instantApply");
	},

	setInstantApplyPref: function(b) {
		return this.service.setBoolPref("browser.preferences.instantApply",b);
	},

	getIntPref: function(p) {
		return this.service.getIntPref(p);
	}

}